#include <iostream>
#include <string.h>
using namespace std;

const int MAXS = 100;
const int MAXPAZ = 20;

enum Lab {SANGUE, ELETTRO};
enum Sesso {MASCHIO, FEMMINA};

struct Paziente {
  char nome[MAXS];
  char cognome[MAXS];
  int eta;
  Sesso sex;
};

struct CodaPazienti {
  Paziente paz[MAXPAZ];
  int front, back;
};

struct Ambulatorio {
  CodaPazienti codaSangue;
  CodaPazienti codaElettro;
};

bool inserisci(Ambulatorio* pa, Paziente p, Lab e) ;
bool desiste(Ambulatorio* pa, const char n[], const char c[]) ;
float etaMedia(const Ambulatorio* pa, Lab e) ;
void stampaOrdinata(const Ambulatorio* pa) ;
bool servizio(Ambulatorio* pa, Lab e) ;

void init(CodaPazienti* pc) {
  pc->front = pc->back = 0;
}

void menu(){
  cout << "---------------------" << endl;
  cout << "1) inserisci paziente" << endl;
  cout << "2) desiste" << endl;
  cout << "3) eta media" << endl;
  cout << "4) stampa ordinata" << endl;
  cout << "5) servizio" << endl;
  cout << "6) esci" << endl;
  cout << "? ";
}

Lab leggiLab(){
  cout << "Che tipo di esame (S=sangue, E=elettro)? ";
  char c;
  cin >> c;
  if(c=='S' || c == 's') return SANGUE;
  return ELETTRO;
}

Paziente leggiPaziente(){
  Paziente p;
  cout << "Inserici nome: ";
  cin >> p.nome;
  cout << "Inserisci cognome: ";
  cin >> p.cognome;
  cout << "Inserisci eta: ";
  cin >> p.eta;
  cout << "Inserisci sesso (M/F): ";
  char c;
  cin >> c;
  p.sex = c=='M' || c=='m' ? MASCHIO : FEMMINA;
  return p;
}

int main(){
  Ambulatorio a;
  init(&a.codaSangue);
  init(&a.codaElettro);
  char c; 
  Lab e;
  float m;
  Paziente p;
  bool r;
  char nom[MAXS];
  char cog[MAXS];
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        p = leggiPaziente();
        e = leggiLab();
        r = inserisci(&a, p, e);
        if(r) cout << "Inserimento ok" << endl;
        else cout << "Non inserito" << endl;
        break;
      case '2':
        cout << "Inserisci nome: ";
        cin >> nom;
        cout << "Inserisci cognome: ";
        cin >> cog;
        r = desiste(&a, nom, cog);
        if(r) cout << "Il paziente e' andato via" << endl;
        else cout << "Paziente non trovato" << endl;
        break;  
      case '3':
        e = leggiLab();
        m = etaMedia(&a, e);
        cout << "Eta media: " << m << endl;
        break; 
      case '4':
        stampaOrdinata(&a);
        break;
      case '5':
        e = leggiLab();
        r = servizio(&a, e);
        if(r) cout << "Un paziente e' stato servito" << endl;
        else cout << "Nessun paziente e' stato servito" << endl;
        break;
      case '6':
        return 0; 
      default:
        cout << "Scelta inesistente" << endl;
    }
  } 
}
